#version 120

attribute vec3 vertexPos;
attribute vec2 vertexUV;
attribute vec3 normalCoords;

varying vec2 UV;
varying vec4 normalVector;
varying vec3 fragPos;

uniform mat4 model;
uniform mat4 view;
uniform mat4 projection;

void main()
{
	UV = vertexUV;
	normalVector = vec4(normalCoords,1.0f);
	fragPos = vec3(model * vec4(vertexPos, 1.0f));

	gl_Position = projection * view * model * vec4(vertexPos,1.0f);

}
