/**
* Actor object
*
* (c) 2017 Jani Nykänen
*/

#ifndef __APPLICATION__ACTOR__
#define __APPLICATION__ACTOR__

#include "../../Engine/Camera/first_person.hpp"
#include "../../Engine/Utility/math.hpp"

#include "../control_state.hpp"
#include "../vpad.hpp"

namespace Application
{
class Actor
{
protected:

    glm::vec3 pos;
    glm::vec3 angle;

    glm::vec3 speed;
    glm::vec3 target;
    glm::vec3 speedMod;
    float totalSpeed; //! The norm of the speed vector

    float radius = 0.5f;

    bool canJump;

    void Move(float timeMod);
    void PointCollision(float x1, float z1,float distance);
    void GetPointCollision(float x1, float z1, float x2, float z2);

public:

    void Update(float timeMod);
    void OnFloorCollision(float a, float b, float c, float d, float timeMod);
    void OnWallCollision(glm::vec3 A, glm::vec3 B, glm::vec3 C, float timeMod);
    void OnTriangleCollision(glm::vec3 A, glm::vec3 B, glm::vec3 C, float timeMod);

    virtual void OnUpdate(float timeMod){};
};
}

#endif // __APPLICATION__ACTOR__

