#include "game.hpp"

using namespace Engine;
using namespace Application;

Application::Game::Game()
{
    Init();
}

void Application::Game::Init()
{
    cam = Camera1stPerson(glm::vec3(0.1f,10.0f,-15.0f));

    pl = new Player(cam.GetPos());
}

void Application::Game::OnLoaded(Engine::Assets* ass)
{
    InitHUD(ass);
    InitStage(ass);
}

void Application::Game::Update(float timeMod)
{
    pl->UpdateCamera(cam);
    pl->Update(timeMod);

    UpdateHUD(timeMod);
    UpdateStage(timeMod);
    OnActorCollision((Actor*)pl,timeMod);
}

void Application::Game::Draw(Graphics* g)
{
    g->SetLinearFilter(true);
    g->SetTexturesEnabled(true);

    g->SetDepthTest(true);
    g->Clear(Color(0.0f,0.0f,0.0f,1.0f));

    g->Identity();
    g->View(cam.GetViewMatrix());
    g->Projection(75.0f,g->GetCanvasSize(),0.1f,200.0f);

    DrawStage(g);
    DrawHUD(g);
}

void Application::Game::Destroy()
{

}
