#include "hud.hpp"

using namespace Engine;
using namespace Application;

void Application::HUD::InitHUD(Engine::Assets* ass)
{
    bmpFont16 = ass->GetBitmap("font16");
    bmpCrosshair = ass->GetBitmap("crosshair");
}

void Application::HUD::DrawHUD(Engine::Graphics* g)
{
    g->Ortho2D(g->GetCanvasSize().x,g->GetCanvasSize().y);
    g->Identity();
    g->UseTransform();

    g->SetDepthTest(false);
    g->SetLinearFilter(false);

    std::string fpsStr = std::to_string((int)round(frameRate));

    g->SetColor(0.0f,0.0f,0.0f,1.0f);
    g->DrawText(bmpFont16,"FPS: " + fpsStr,2.0f,2.0f);

    g->SetColor(1.0f,1.0f,1.0f,1.0f);
    g->DrawText(bmpFont16,"FPS: " + fpsStr,1.0f,1.0f);

    g->SetColor(0.0f,0.0f,0.0f,1.0f);
    g->DrawText(bmpFont16,"Press L.Ctrl + Q to quit",2.0f,240-12);

    g->SetColor(1.0f,1.0f,1.0f,1.0f);
    g->DrawText(bmpFont16,"Press L.Ctrl + Q to quit",1.0f,240-12-1);

    g->DrawBitmap(bmpCrosshair,g->GetCanvasSize().x/2 - 16, g->GetCanvasSize().y/2 - 16);
}

void Application::HUD::UpdateHUD(float timeMod)
{
    frameRate = 60.0f / timeMod;
}
