/**
* Stage
*
* (c) 2017 Jani Nykänen
*/

#ifndef __APPLICATION__GAME_STAGE__
#define __APPLICATION__GAME_STAGE__


#include "../../Engine/Renderer/model.hpp"
#include "../../Engine/Renderer/bitmap.hpp"
#include "../../Engine/Camera/first_person.hpp"
#include "../../Engine/Loader/asset_loader.hpp"
#include "../../Engine/Renderer/graphics.hpp"

#include "actor.hpp"

namespace Application
{
class Stage
{
private:

    void GetModelCollision(Actor*ac, Engine::Model* m, glm::vec3 scale, float timeMod);

protected:

    Engine::Camera1stPerson cam;

    //! Assets
    Engine::Model* mRoom;
    Engine::Model* mCylinder;
    Engine::Model* mSkybox;
    Engine::Bitmap* bmpCityBg;
    Engine::Bitmap* bmpSky;

    //! Methods
    void InitStage(Engine::Assets* ass);
    void DrawStage(Engine::Graphics* g);
    void UpdateStage(float timeMod);
    void OnActorCollision(Actor* ac, float timeMod);

};
}

#endif // __APPLICATION__GAME_STAGE__
