/**
* Application
* Configuration data
*
* (c) 2017 Jani Nykänen
*/

#ifndef __APPLICATION__CONFIG__
#define __APPLICATION__CONFIG__

#include <vector>
#include <string>

#include "../Engine/Types/point.hpp"
#include "../Library/clumsy-ml.hpp"

namespace Application
{

/**
* A simple structure to hold configuration data
* needed in this project
*/
struct Config
{
    Point defaultWinSize;
    bool defaultFullscreenEnabled;
    bool canvasEnabled;
    float fps;
    Point canvasSize;
    std::string assetPath;
    std::string shaderPath;
    int canvasFill;
};

/**
* Read configuration filed
*/
Config ReadConfigFile(std::string path);

};

#endif // __APPLICATION__CONFIG__

