/**
* Application
* Control state
*
* (c) 2017 Jani Nykänen
**/

#ifndef __APPLICATION__CONTROL_STATE__
#define __APPLICATION__CONTROL_STATE__

#include <iostream>
#include <string>
#include <vector>
#include <fstream>

#include <GLFW/glfw3.h>

#define GLM_FORCE_RADIANS
#include <glm/glm.hpp>
#include <glm/gtc/matrix_transform.hpp>

namespace Application
{
enum State
{
Up = 0,
Down = 1,
Pressed = 2,
Released = 3,
};

namespace ControlState
{

void Init();
void Update();
void OnKeyDown(int key);
void OnKeyUp(int key);
void OnMouseMove(double x, double y);
void OnMouseDown(int button);
void OnMouseUp(int button);

State GetKeyState(int key);
State GetMouseState(int button);

glm::vec2 GetMousePos();
glm::vec2 GetRelativeMousePos();
glm::vec2 GetMouseDelta();

void SetProportions(glm::vec2 ndim, glm::vec2 cs);

};
};

#endif // __APPLICATION__CONTROL_STATE__

