/**
* Application
* Scene
*
* Just an interface, or abstact base class or whatever
*
* (c) 2017 Jani Nykänen
*/

#ifndef __APPLICATION__SCENE__
#define __APPLICATION__SCENE__

#include "../Engine/Renderer/graphics.hpp"
#include "../Engine/Renderer/shader.hpp"
#include "../Engine/Loader/asset_loader.hpp"

namespace Application
{

class Scene
{
public:

    virtual void Init() =0;
    virtual void Update(float timeMod) =0;
    virtual void Draw(Engine::Graphics* g) =0;
    virtual void Destroy() =0;
    virtual void OnLoaded(Engine::Assets* ass) =0;
};

};

#endif // __APPLICATION__SCENE__
