#include "first_person.hpp"

using namespace Engine;

/**
* Private functions
*/
void Engine::Camera1stPerson::SetLookAt()
{
    lookAt.x = pos.x + cos(angle.x) * sin(angle.y);
    lookAt.y = pos.y + sin(angle.x);
    lookAt.z = pos.z + cos(angle.x) * cos(angle.y);
}

//!-------------------------------------//

/**
* Public functions
*/
Engine::Camera1stPerson::Camera1stPerson(glm::vec3 newPos)
{
    pos = newPos;
    angle = glm::vec3();
}

glm::mat4 Engine::Camera1stPerson::GetViewMatrix()
{
    SetLookAt();
    return glm::lookAt(pos,lookAt,glm::vec3(0,1,0));
}
