/**
* Engine
* First-person camera
*
* (c) 2017 Jani Nykänen
*/

#ifndef __ENGINE__CAMERA_1st__
#define __ENGINE__CAMERA_1st__

#define GLM_FORCE_RADIANS
#include <glm/glm.hpp>
#include <glm/gtc/matrix_transform.hpp>

#include "camera.hpp"

namespace Engine
{
class Camera1stPerson : public Camera
{
private:

    glm::vec3 angle;

    void SetLookAt();

public:

    inline Camera1stPerson(){};
    Camera1stPerson(glm::vec3 pos);

    inline void SetPos(glm::vec3 newPos) {pos = newPos;};
    inline void SetAngle(glm::vec3 newAngle) {angle = newAngle;};

    inline glm::vec3 GetPos() {return pos;}
    inline glm::vec3 GetAngle(){return angle;}

    inline void Rotate(float amount, glm::vec3 dangle) {angle += dangle*amount;};

    glm::mat4 GetViewMatrix();

};
}

#endif // __ENGINE__CAMERA_1st__
