#include "display_handle.hpp"

using namespace Engine;

void Engine::DisplayHandle::ToggleFulscreen()
{
    GLFWmonitor* monitor = glfwGetPrimaryMonitor();
    const GLFWvidmode* mode = glfwGetVideoMode(monitor);

    if(fullscreen == false)
    {
        glfwGetWindowSize(window,&oldWidth,&oldHeight);
        glfwSetWindowMonitor(window, monitor, 0, 0, mode->width, mode->height, mode->refreshRate);
    }
    else
    {
        glfwSetWindowMonitor(window, nullptr,mode->width/2 - oldWidth/2,mode->height/2 - oldHeight/2, oldWidth, oldHeight, 0);
    }
    fullscreen = !fullscreen;
}

void Engine::DisplayHandle::InitDisplayHandle()
{
    fullscreen = false;
}
