/**
* Engine
* Display handle
*
* (c) 2017 Jani Nykänen
*/

#ifndef __ENGINE__CORE_DISPLAY__
#define __ENGINE__CORE_DISPLAY__

#include <vector>
#include <stdexcept>
#include <iostream>

#include <GL/glew.h>
#include <GLFW/glfw3.h>

namespace Engine
{

class DisplayHandle
{
private:

    bool fullscreen;

    int oldTop;
    int oldLeft;
    int oldWidth;
    int oldHeight;

protected:

    GLFWwindow * window;

public:

    void ToggleFulscreen();
    void InitDisplayHandle();

};

}

#endif // __ENGINE__CORE_DISPLAY__

