#include "events.hpp"

using namespace Engine;

/**
* Static variables
*/
static EventHandle* refObject;

/**
*   Callbacks
*/

void cb__KeyEvents(GLFWwindow* window, int key, int scancode, int action, int mods)
{
    if (action == GLFW_PRESS)
    {
        refObject->OnKeyDown(key);
    }
    else if (action == GLFW_RELEASE)
    {
        refObject->OnKeyUp(key);
    }
}

void cb__MousePos(GLFWwindow* window, double xpos, double ypos)
{
    refObject->OnMouseMove(xpos,ypos);
}

void cb__MouseButton(GLFWwindow* window, int button, int action, int mods)
{
    if (action == GLFW_PRESS)
    {
        refObject->OnMouseDown(button);
    }
    else if (action == GLFW_RELEASE)
    {
        refObject->OnMouseUp(button);
    }
}

void cb__MouseWheel(GLFWwindow* window, double xoffset, double yoffset)
{
    refObject->OnMouseWheel(yoffset);
}

void cb__WindowResize(GLFWwindow* window, int width, int height)
{
    refObject->OnResizeEvent(width,height);
}

/**
*   Public class methods
*/

void Engine::EventHandle::InitEventHandle(GLFWwindow* window)
{
    refObject = this;

    glfwSetKeyCallback(window, cb__KeyEvents);
    glfwSetWindowSizeCallback(window,cb__WindowResize);
    glfwSetCursorPosCallback(window,cb__MousePos);
    glfwSetScrollCallback(window,cb__MouseWheel);
    glfwSetMouseButtonCallback(window,cb__MouseButton);
}
