/**
* Engine
* Event handle
*
* (c) 2017 Jani Nykänen
*/

#ifndef __ENGINE__CORE_EVENTS__
#define __ENGINE__CORE_EVENTS__

#include <vector>
#include <stdexcept>
#include <iostream>

#include <GL/glew.h>
#include <GLFW/glfw3.h>

namespace Engine
{

class EventHandle
{
public:

    virtual void OnKeyDown(int key) {};
    virtual void OnKeyUp(int key) {};

    virtual void OnMouseMove(double x, double y) {};
    virtual void OnMouseDown(int button) {};
    virtual void OnMouseUp(int button) {};
    virtual void OnMouseWheel(double offset) {};

    virtual void OnResizeEvent(int width, int height) {};

    void InitEventHandle(GLFWwindow* win);

};

}

#endif // __ENGINE__CORE_EVENTS__
