/**
* Engine
* Bitmap Class
*
* (c) 2017 Jani Nykänen
*/

#ifndef __ENGINE__BITMAPS__
#define __ENGINE__BITMAPS__

#include <string>
#include <stdexcept>
#include <stdlib.h>
#include <cstring>
#include <iostream>

#include <SOIL/SOIL.h>
#include <GL/gl.h>

#include "../Types/point.hpp"

namespace Engine
{
class Bitmap
{
private:

    GLuint texture;
    Point size;

public:

    Bitmap(GLuint ntex, int w, int h);

    inline GLuint GetTexture() { return texture; }
    inline Point GetSize() { return size; }
};

struct RawBitmap
{
    int width;
    int height;
    int channels;
    unsigned char* data;

    inline RawBitmap()
    {
        width = 0;
        height = 0;
        channels = 0;
        data = nullptr;
    }

};

RawBitmap* LoadRawTexture(std::string path);
Bitmap * LoadBitmap(std::string path);
Bitmap * RawTextureToBitmap(RawBitmap* rw);

}


#endif // __ENGINE__BITMAPS__
