/**
* Engine
* Graphics core class
*
* Description: this class is used to draw things
*   extends every other graphics class
*
* (c) 2017 Jani Nykänen
*/

#ifndef __ENGINE__GRAPHICS_CORE__
#define __ENGINE__GRAPHICS_CORE__

#include <vector>
#include <stdexcept>
#include <iostream>

#include "transform.hpp"
#include "effects.hpp"
#include "shader.hpp"
#include "render_utility.hpp"
#include "partition.hpp"
namespace Engine
{

class Graphics : public RenderUtility
{
private:

    Point canvasSize; //! If the application has a canvas

public:

    /**
    * Graphics constructor & destructor
    */
    Graphics();
    ~Graphics();

    inline void SetWinSize(Point p) {winSize = p;};
    inline Point GetWinSize() { return winSize; }

    inline void SetCanvasSize(Point p) {canvasSize = p;}
    inline Point GetCanvasSize() { return canvasSize;}
};

}

#endif // __ENGINE__GRAPHICS_CORE__
