/**
* Engine
* Mesh
*
* (c) 2017 Jani Nykänen
*/

#ifndef __ENGINE__MESH__
#define __ENGINE__MESH__

#include <GL/glew.h>
#include <GL/gl.h>

#define GLM_FORCE_RADIANS
#include <glm/glm.hpp>
#include <glm/gtc/matrix_transform.hpp>

#include <vector>
#include <iostream>

#include "bitmap.hpp"

/**
 @todo Comment this shit
*/

namespace Engine
{

class Mesh
{
private:

    GLuint vArrObj;
    GLuint iArrObj;
    GLuint tArrObj;
    GLuint nArrObj;

    std::vector<GLfloat> vertexArray;
    std::vector<GLuint> indexArray;
    std::vector<GLfloat> texCoordArray;
    std::vector<GLfloat> normalArray;

    bool clamp = false;

public:

    Mesh();
    Mesh(std::vector<GLfloat> vArr, std::vector<GLuint> indArr, std::vector<GLfloat> texArr, std::vector<GLfloat> nrmArr);

    void Draw(Bitmap* bmp, bool linFilter=true);
    void Draw(GLuint tex, bool linFilter= true);
    void SetClamping(bool value);

    inline std::vector<GLfloat> GetVertexArray() { return vertexArray; }
    inline std::vector<GLuint> GetIndexArray() { return indexArray; }
    inline std::vector<GLfloat> GetNormalArray() { return normalArray; }

    void NewVertices(std::vector<GLfloat> nvert);
    void NewUVCoords(std::vector<GLfloat> nuv);
};

}

#endif // __ENGINE__MESH__


