/**
* Engine
*
* Simple static 3D model
* 'cause boning is for losers
*
*(c) 2017 Jani Nykänen
*/

#ifndef __ENGINE__MODEL__
#define __ENGINE__MODEL__

#include "mesh.hpp"

#include "../../Library/tiny_obj_loader.h"

namespace Engine
{

/**
* It's da model!
*/
class Model
{
private:

    std::vector<Mesh*> meshes;

public:

    Model();
    Model(std::vector<Mesh*> mArr);
    ~Model();

    void PushMesh(Mesh* m);
    void PopMesh();

    void Draw(std::vector<Bitmap*> bmpArray, bool linFilter= true);
    void Draw(Bitmap* bmp, bool linFilter= true);

    Mesh * GetMesh(unsigned int id);
};

/**
* Raw model data
* To make sure models can be loaded
* in another threads
*/
struct RawMesh
{
    std::vector<GLfloat> vArr;
    std::vector<GLuint> iArr;
    std::vector<GLfloat> tArr;
    std::vector<GLfloat> nArr;

    inline RawMesh() {vArr.clear(); iArr.clear(); tArr.clear(); nArr.clear();}
};

struct RawModel
{
    std::vector<RawMesh*> meshes;

    RawModel(){meshes = std::vector<RawMesh*> ();}
};

RawModel * LoadRawModel(std::string path);
Model * RawToModel(RawModel* m);

}

#endif // __ENGINE__MODEL__


