/**
* Engine
* 2D image partition
* Used to render text
*
* (c) 2017 Jani Nykänen
*/

#ifndef __ENGINE__PARTITION__
#define __ENGINE__PARTITION__

#include "mesh.hpp"
#include "bitmap.hpp"
#include "../Types/point.hpp"

namespace Engine
{

typedef std::vector<GLfloat> GLFVec;

class Partition
{
private:
    Point size;
    std::vector<GLfloat> vertexArray;
    std::vector<GLfloat> normalArray;
    std::vector<GLFVec> uvArrays;
    std::vector<GLuint> indexArray;

    GLuint vArrObj;
    std::vector<GLuint> tArrObjs;
    GLuint nArrObj;
    GLuint iArrObj;

    void Generate();

public:

    Partition(Point nsize);
    void Draw(Bitmap* bmp, unsigned int column, unsigned int row, bool linFilter = true);

    inline Point GetSize() { return size; }
};

class PartitionHandle
{
private:

    std::vector<Partition*> partitions;

protected:

    void InitPartitionHandle();

    void CreatePartition(Point nsize);
    Partition* GetPartition(Point size);

};

}

#endif // __ENGINE__PARTITION__
