/**
* Engine
* Render target
*
* (c) 2017 Jani Nykänen
*/

#ifndef __ENGINE__RENDER_TARGET__
#define __ENGINE__RENDER_TARGET__

#include <GL/glew.h>
#include <GL/glext.h>
#include <GL/gl.h>
#include <GL/glu.h>

#include "../Types/point.hpp"

#include <vector>
#include <stdexcept>

namespace Engine
{
class RenderTarget
{
private:

    GLuint frameBuffer;
    GLuint depthBuffer;

    int width;
    int height;

    GLuint texture;

public:

    RenderTarget(int w, int h);

    void UseFrameBuffer();

    Point GetSize();
    GLuint GetTexture();
};

RenderTarget * CreateRenderTarget(int width, int height);

}

#endif // __ENGINE__RENDER_TARGET__
