/**
* Engine
* Graphics: Shader class
*
* (c) 2017 Jani Nykänen
**/

#ifndef __ENGINE__SHADER__
#define __ENGINE__SHADER__

#include <iostream>
#include <string>
#include <vector>
#include <fstream>
#include <stdexcept>

#include <GL/glew.h>
#include <GL/glext.h>
#include <GL/gl.h>

namespace Engine
{

/**
* Shader class
*/
class Shader
{
private:

    GLuint shaderProgram;

public:
    Shader(std::string vertexPath,std::string fragPath);
    ~Shader();

    void Enable();
    void Disable();
    GLuint GetProgram();
};

/**
* External function for loading shaders, pretty much same as new Shader( ... )
*/
Shader * LoadShader(std::string vertexPath,std::string fragPath);

};

#endif // __ENGINE__SHADER__
