#include "math.hpp"

/**
* Possible @todo :
* See if there are any performance losses if you make ...XY swap Y and Z and then call ...XZ
*/

bool Engine::Math::IsInsideTriangleXZ(glm::vec3 T, glm::vec3 A, glm::vec3 B, glm::vec3 C)
{
    double as_x = T.x-A.x;
    double as_z = T.z-A.z;

    bool s_ab = (B.x-A.x)*as_z-(B.z-A.z)*as_x > 0;

    return
        ( (((C.x-A.x)*as_z-(C.z-A.z)*as_x > 0) == s_ab)
        || (((C.x-B.x)*(T.z-B.z)-(C.z-B.z)*(T.x-B.x) > 0) != s_ab) )
        ? false : true;
}

bool Engine::Math::IsInsideTriangleXY(glm::vec3 T, glm::vec3 A, glm::vec3 B, glm::vec3 C)
{
    double as_x = T.x-A.x;
    double as_z = T.y-A.y;

    bool s_ab = (B.x-A.x)*as_z-(B.y-A.y)*as_x > 0;

    return
        ( (((C.x-A.x)*as_z-(C.y-A.y)*as_x > 0) == s_ab)
        || (((C.x-B.x)*(T.y-B.y)-(C.y-B.y)*(T.x-B.x) > 0) != s_ab) )
        ? false : true;
}

bool Engine::Math::IsInsideTriangleYZ(glm::vec3 T, glm::vec3 A, glm::vec3 B, glm::vec3 C)
{
    double as_x = T.z-A.z;
    double as_z = T.y-A.y;

    bool s_ab = (B.z-A.z)*as_z-(B.y-A.y)*as_x > 0;

    return
        ( (((C.z-A.z)*as_z-(C.y-A.y)*as_x > 0) == s_ab)
        || (((C.z-B.z)*(T.y-B.y)-(C.y-B.y)*(T.z-B.z) > 0) != s_ab) )
        ? false : true;
}
