/*
    Clumsy-ML v.0.2.0 parser

    (c) 2016 Jani Nykänen
*/

#ifndef __CLUMSY_MARKING_LANGUAGE_PARSER__
#define __CLUMSY_MARKING_LANGUAGE_PARSER__

#include <vector>
#include <string>
#include <fstream>
#include <iostream>
#include <algorithm>
#include <stdexcept>


namespace ClumsyML
{
struct Keypair
{
    std::string key;
    std::string value;

    Keypair();
    Keypair(std::string nkey, std::string nvalue);
};

class Node
{
private:

    std::string name;
    std::vector<Keypair> attributes;

    std::vector<Node*> nodes;

public:

    std::vector<Node*> GetNodes();
    std::vector<Keypair> GetAttributes();

    Node* PushNode(std::string name);
    void PushAttribute(Keypair kp);

    std::string GetName();

    Node();
    Node(std::string name);
    ~Node();
};

class Document
{
private:

    std::vector<Node*> nodes;
    Node * currentNode;
    std::vector<Node *> lastNodes;

public:

    void SetCurrentNode(Node * n);
    Node* GetCurrentNode();

    void SetLastNode(Node * n);
    void UsePreviousNode();
    Node* GetPreviousNode();

    Node* PushNode(std::string name);
    std::vector<Node*> GetNodes();

    Document();
    ~Document();

};

Document* LoadDocument(std::string path);

};

#endif // __CLUMSY_MARKING_LANGUAGE_PARSER__
